From: Michael Tremer <michael.tremer@ipfire.org>
To: network@lists.ipfire.org
Subject: Re: [PATCH v2 1/4] util: add copy function
Date: Sat, 15 Jul 2017 18:06:33 -0400 [thread overview]
Message-ID: <26f3efd2e9926f3333523623830a0332@ipfire.org> (raw)
In-Reply-To: <1500146346-8819-1-git-send-email-jonatan.schlag@ipfire.org>
[-- Attachment #1: Type: text/plain, Size: 1719 bytes --]
Hi,
there is a few bugs in this function...
On 15/07/2017 03:19 PM, Jonatan Schlag wrote:
> Adds a nice function to copy simple configuration files.
>
> Signed-off-by: Jonatan Schlag <jonatan.schlag(a)ipfire.org>
> ---
> src/functions/functions.util | 26 ++++++++++++++++++++++++++
> 1 file changed, 26 insertions(+)
>
> diff --git a/src/functions/functions.util
> b/src/functions/functions.util
> index 0a9b3d6..a6c98c6 100644
> --- a/src/functions/functions.util
> +++ b/src/functions/functions.util
> @@ -766,3 +766,29 @@ hex2dec() {
> dec2hex() {
> printf "%02x\n" "${1}"
> }
> +
> +
> +copy() {
> + # This function just copy to config files
> + assert [ $# -eq 2 ]
> + src=${1}
> + dst=${2}
The local keyword is missing here.
> + local data=$(fread ${src})
> + if [ ! $? -eq 0 ]; then
> + log ERROR "Could not read data from ${src}"
> + return ${EXIT_ERROR}
> + fi
Are you sure that $? is set to the exit code of fread here?
It might be that the shell sets that if the variable assignment
to local was successful (which it always is). I think you might
need to use the ${PIPESTATUS} array here.
> + if [ -e ${dst} ]; then
> + log ERROR "Destination ${dst} already exist"
> + return ${EXIT_ERROR}
> + else
> + touch ${dst}
> + fi
Is that a problem when the destination already exists? I think
we should allow copy() to overwrite files.
What we do need to check though is if $dst is a directory. In that
case we cannot write to it.
And there is no need to touch the file when it does not exist,
yet. fwrite will create it (I hope - if not change fwrite).
> + if ! fwrite ${dst} "${data}"; then
> + log ERROR "Could not write data to ${dst}"
> + return ${EXIT_ERROR}
> + fi
> +}
-Michael
prev parent reply other threads:[~2017-07-15 22:06 UTC|newest]
Thread overview: 6+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-07-15 19:19 Jonatan Schlag
2017-07-15 19:19 ` [PATCH v2 2/4] constants: add new constant NETWROK_SHARE_DIR Jonatan Schlag
2017-07-15 22:07 ` Michael Tremer
2017-07-15 19:19 ` [PATCH v2 3/4] Add new feature vpn security policies Jonatan Schlag
2017-07-15 19:19 ` [PATCH v2 4/4] Add vpn security policies to cli Jonatan Schlag
2017-07-15 22:06 ` Michael Tremer [this message]
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=26f3efd2e9926f3333523623830a0332@ipfire.org \
--to=michael.tremer@ipfire.org \
--cc=network@lists.ipfire.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox